x=-7:0.1:7;
f=@(x,c)-10*x.^4+60*x.^2-120+c;
plot(x,f(x,0),'k')
axis('square',[-7 7 -150 150])

%%
% cvals=0:1:100;
% for k=1:numel(cvals)
%     f=@(x)-10*x.^4+60*x.^2-120+cvals(k);
%     [xstar{k}]=nfzero(f,x);
% end

c=0:1:200;
l1=sqrt(3-sqrt(0.1*c-3));
l2=-sqrt(3-sqrt(0.1*c-3));
l3=sqrt(3+sqrt(0.1*c-3));
l4=-sqrt(3+sqrt(0.1*c-3));
il1=imag(l1)==0;
il2=imag(l2)==0;
il3=imag(l3)==0;
il4=imag(l4)==0;
plot(c(il1),l1(il1),'--k',c(il2),l2(il2),'k',c(il3),l3(il3),'k',c(il4),l4(il4),'--k','linewidth',7)
line([0 max(c)],[0 0],'color','k','linewidth',4)
line(0.7*[1 1],[-3 3],'color','k','linewidth',4)
xlim([0 max(c)])
set(gca,'xtick',[],'ytick',[],'box','off','visible','off')
text(190,-0.3,'c','fontsize',36)
text(-20,2.8,'x*','fontsize',36)
text(-13,0,'0','fontsize',36)
print(1,'bifurcation_soln.eps','-depsc2')

%%
dt=0.000001;
time=0:dt:0.03;
x=repmat(time*0,5,1);
x(:,1)=[-2.5 -1.8 -0.01 1.8 2.5];
for k=1:5
    for t=2:numel(time)
        x(k,t)=x(k,t-1)+dt*(f(x(k,t-1),75));
    end
end
%%
figure(2); clf;
line([time(1) time(end)],[0 0],'color','k','linewidth',2)
line([0 0]+0.0001,[-8 4],'color','k','linewidth',2)
clrs=jet(5);
h=zeros(5,1);
for k=1:5
    h(k)=line(time,x(k,:),'color',clrs(k,:),'linewidth',5);
end
ylim([-8 4])
set(gca,'visible','off')
text(0.029,0.6,'t','fontsize',28)
text(-0.0013,3.68,'x','fontsize',28)
legend(h,{'1','2','3','4','5'},'location','southeast','fontsize',20,'visible','off')

print(2,'dynamics_sketch.eps','-depsc2')
