%% ---------------- Problem 5e
% -------- initialize parameters and allocate memory
dt=0.01;
T=10;
time=0:dt:T;
w=[0.25 1];
x0=0.5;
x=repmat(time,2,1)*0;
x(:,1)=x0;
% -------- run the simulation
for k=1:2
    for t=2:numel(time)
        x(k,t)=x(k,t-1)+dt*(-x(k,t-1)+w(k)*tanh(x(k,t-1)));
    end
end
% -------- plot
plot(time,x(1,:),'k',time,x(2,:),'b','linewidth',4)
xlabel('time (s)','fontsize',16)
ylabel('x','fontsize',16)
set(gca,'fontsize',12,'ytick',0:0.1:0.5,'xtick',0:2:10)
legend(['w = ' sprintf('%3.2f',w(1))],['w = ' sprintf('%3.2f',w(2))])

%% ---------------- Problem 5f i
% -------- initialize parameters and allocate memory
dt=0.01;
T=10;
time=0:dt:T;
w=2;
sigma=0;
x0=0;
x=time*0;
x(:,1)=x0;
% -------- run the simulation
for t=2:numel(time)
    x(t)=x(t-1)+dt*(-x(t-1)+w*tanh(x(t-1)))+sigma*sqrt(dt);
end
% -------- plot
plot(time,x,'k','linewidth',4)
xlabel('time (s)','fontsize',16)
ylabel('x','fontsize',16)
set(gca,'fontsize',12,'ytick',-1:0.2:1,'xtick',0:2:10)
% legend(['w = ' sprintf('%3.2f',w(1))],['w = ' sprintf('%3.2f',w(2))])

%% ---------------- Problem 5f ii
% -------- initialize parameters and allocate memory
dt=0.01;
T=100;
time=0:dt:T;
w=2;
sigma=0.1;
x0=0;
x=zeros(10,numel(time));
x(:,1)=x0;
% -------- run the simulation
for k=1:10;
    for t=2:numel(time)
        x(k,t)=x(k,t-1)+dt*(-x(k,t-1)+w*tanh(x(k,t-1)))+sigma*sqrt(dt)*randn;
    end
end
% -------- plot
figure(1); clf
for k=1:10
    if x(k,end)>0, c=[0.9 0.5 0.5]; else c=[0.5 0.5 0.9]; end % color based on final decision reached
    line(time,x(k,:),'color',c)
end
xlabel('time (s)','fontsize',16)
ylabel('x','fontsize',16)
set(gca,'fontsize',12,'ytick',-2:0.5:2,'xtick',0:2:10)
ylim([-2.1 2.1])
% legend(['w = ' sprintf('%3.2f',w(1))],['w = ' sprintf('%3.2f',w(2))])

%% ---------------- Problem 6a
dummyx=-3:0.5:3;
dummyy=-3:0.5:3;
[X,Y]=meshgrid(dummyx,dummyy);

figure(1); clf;
fp=get(1,'position');
set(1,'position',[fp(1:2) 800 400]);
w=[0.5 2];
for k=1:2
    subplot(1,2,k);
    quiver(X,Y,-X-w(k)*tanh(Y),-Y-w(k)*tanh(X),'color',0.6*ones(1,3));
    line(dummyx,-w(k)*tanh(dummyx),'color','r','linewidth',3);
    line(-w(k)*tanh(dummyy),dummyy,'color','k','linewidth',3);
%     line(dummyx,atanh(-dummyx/w(k)),'color','r');
%     line(atanh(-dummyy/w(k)),dummyy,'color','k');
    axis([min(dummyx) max(dummyx) min(dummyy) max(dummyy)],'square')
end

%% ---------------- Problem 6d
dt=0.01;
T=10;
time=0:dt:T;
w=0.5;
sigma=0.1;
N=10;
x=repmat(time*0,N,1);
y=x;
x(:,1)=0;
y(:,1)=0;
for n=1:N
    for t=2:numel(time)
        x(n,t)=x(n,t-1)+dt*(-x(n,t-1)+w*tanh(y(n,t-1)))+sigma*sqrt(dt)*randn;
        y(n,t)=y(n,t-1)+dt*(-y(n,t-1)+w*tanh(x(n,t-1)))+sigma*sqrt(dt)*randn;
    end
end
figure(2);
plot(time,x,'c',time,y,'m')
ylim([-2 2])

% ---------------- Problem 6e
dt=0.01;
T=10;
time=0:dt:T;
w=2;
sigma=0.1;
N=10;
x=repmat(time*0,N,1);
y=x;
x(:,1)=0;
y(:,1)=0;
for n=1:N
    for t=2:numel(time)
        x(n,t)=x(n,t-1)+dt*(-x(n,t-1)+w*tanh(y(n,t-1)))+sigma*sqrt(dt)*randn;
        y(n,t)=y(n,t-1)+dt*(-y(n,t-1)+w*tanh(x(n,t-1)))+sigma*sqrt(dt)*randn;
    end
end
x0=time*0;
y0=x0;
sigma=0;
for t=2:numel(time)
    x0(t)=x0(t-1)+dt*(-x0(t-1)+w*tanh(y0(t-1)))+sigma*sqrt(dt)*randn;
    y0(t)=y0(t-1)+dt*(-y0(t-1)+w*tanh(x0(t-1)))+sigma*sqrt(dt)*randn;
end
figure(3);
plot(time,x,'c',time,y,'m',time,x0,'k',time,y0,'k')
ylim([-2 2])








